/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	CatalogLoセットアップクラス
//			新規作成
//				2004.01.08 新規作成 kin 
//

package jp.co.ntt.lms.lo.Catalog;

import jp.co.ntt.lms.lo.*;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.XMODate;

import java.util.Date;
import java.util.Hashtable;
import java.util.Vector;

import org.apache.commons.lang.StringEscapeUtils;

/**
 * セットアップインタフェースクラス
 *
 * <PRE>
 *   CatalogLoの編集(登録・更新・削除・ユーザ登録・ユーザ削除)をする。
 *   上位にセットアップインタフェースクラスを持つ。
 * </PRE>
 *
 */
public class CatalogLoSetup extends Setup
	implements CatalogLoTable
{
	////////////////////////////////////////////////////////////////////////////
	// 抽象メソッドの実装
	////////////////////////////////////////////////////////////////////////////
	/**
	 * セットアップ登録処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupInsert(Hashtable htbParam)
			throws LOException
	{
		//CatalogLOテーブルへの登録
		CatalogLoDataAccess objDataAccess = new CatalogLoDataAccess();

		objDataAccess.insert( htbParam );

	}

	/**
	 * セットアップ更新処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupUpdate(Hashtable htbParam)
			throws LOException
	{
		//CatalogLoテーブルの更新
		CatalogLoDataAccess objDataAccess = new CatalogLoDataAccess();

		objDataAccess.update( htbParam );

	}

	/**
	 * セットアップ削除処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupDelete(Hashtable htbParam)
			throws LOException
	{
		//CatalogLoテーブルの削除
		CatalogLoDataAccess objDataAccess = new CatalogLoDataAccess();

		objDataAccess.delete( htbParam );

	}

	/**
	 * セットアップユーザ登録処理
	 *
	 * @param htbParam パラメータリスト
	 * @return void
	 * @exception LOException
	 */
	protected void setupAddUser(Hashtable htbParam)
		throws LOException
	{
		// @pending ここに処理を記述します
	}


	/**
	 * セットアップユーザ削除処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected void setupDelUser(Hashtable htbParam)
		throws LOException
	{
		// @pending ここに処理を記述します
	}

	/**
	 * セットアップコピー処理
	 *
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 */
	protected void setupCopy(Hashtable htbParam)
		throws LOException
	{
		String strLoID = (String)htbParam.get( LOID );		//コピー後LOID
		String strCopyLoID = (String)htbParam.get( LO_COPY_ID );//コピー元LOID

		// Dataアクセスクラスを使用して、詳細情報を取得する
	
		CatalogLoDataAccess objDataAccess = new CatalogLoDataAccess();
	
		if(strCopyLoID != null && !strCopyLoID.equals("")){

			String sbCondition =" WHERE "+"LOID ="+" '" + StringEscapeUtils.escapeSql(strCopyLoID) + "'";

			htbParam.put(CONDITION_KEY, sbCondition);

			//コピーデータを格納用
			Hashtable htbCopy = new Hashtable();

			//コピー元のRealIDをキーにしてCatalogLoテーブルを検索する
			 SelectCatalogLoCopy(htbParam,htbCopy,objDataAccess);

			//コピー元のRealIDをキーにしてCatalogLoListテーブルを検索する
			 SelectCatalogLoListCopy(htbParam,htbCopy,objDataAccess);
		
			//CatalogLoとCatalogLoListテーブルにコピーデータを登録する

			setupInsert( htbCopy );
		}

	}

	/**
	 * コピー元のRealIDをキーにしてCatalogLoテーブルを検索処理
	 * @param htbCopy コピーデータ保持
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 * @return 
	 */

	private void SelectCatalogLoCopy(Hashtable htbParam,Hashtable htbCopy,CatalogLoDataAccess objDataAccess)
		throws LOException
	{
			
		CatalogLoData[] objOrignal = objDataAccess.getData( htbParam );

		// CatalogLo個別にセットする
		putData( htbCopy, (String)htbParam.get( LOID ),LOID );
		putData( htbCopy, (String)objOrignal[0].getWinHeight(),WINHEIGHT );
		putData( htbCopy, (String)objOrignal[0].getWinWidth(),WINWIDTH );

	}

	/**
	 * コピー元のRealIDをキーにしてCatalogLoListテーブルを検索処理
	 * @param htbCopy コピーデータ保持
	 * @param htbParam パラメータリスト
	 * @exception LOException
	 * @return 
	 */
	private void SelectCatalogLoListCopy(Hashtable htbParam,Hashtable htbCopy,CatalogLoDataAccess objDataAccess)
		throws LOException
	{

		CatalogLoData[] objOrignal = objDataAccess.getData( htbParam );
		CatalogLoListData[] objOrignalList = objOrignal[0].getLoList();

		Vector vecList = new Vector();
		CatalogLoData ObjData = new CatalogLoData ();

		//取得したデータをリストにセットする
		for (int i=0; i<objOrignalList.length; i++){
			CatalogLoListData ObjListData = new CatalogLoListData();

			ObjListData.setLOID((String)htbParam.get( LOID ));
			ObjListData.setCatalogListLOID((String)objOrignalList[i].getCatalogListLOID());
			ObjListData.setSortNo((String)objOrignalList[i].getSortNo());

			//CatalogListDataをVectorに入れる
			vecList.add(ObjListData);				
		}
		//CatalogListDataオブジェクトをセットする。
		CatalogLoListData[] objList = new CatalogLoListData[vecList.size()];
		vecList.copyInto(objList);
		ObjData.setLoList(objList);
	
		putDataList( htbCopy,ObjData,CATALOG_LIST_DATA);
		
	}

	/**
	 * 安全にCatalogLOデータをHashtableに追加するメソッドです
	 */
	private void putData( Hashtable htbData, String strValue, String strKey ) {
		if( strKey != null ) {
			htbData.put( strKey, strValue );
		}
	}
	/**
	 * 安全にCatalogLOListデータをHashtableに追加するメソッドです
	 */
	private void putDataList( Hashtable htbData, CatalogLoData strValue, String strKey ) {
		if( strKey != null ) {
			htbData.put( strKey, strValue );
		}
	}


}
